#include "string_matcher.h"
#include <catch.h>

using namespace string_matcher;

TEST_CASE("Matcher for a")
{
    String_matcher m = equals("a");

    CHECK(m.matches("a"));
    CHECK_FALSE(m.matches("b"));

    CHECK(m.to_string() == "(equals \"a\")");
}

TEST_CASE("Negation matcher")
{
    auto m = !equals("a");

    CHECK_FALSE( m.matches("a") );
    CHECK( m.matches("b") );
}

TEST_CASE("String matchers")
{
    auto m = starts_with("Hello") && (ends_with(".") || ends_with("!"));

    CHECK( m.matches("Hello.") );
    CHECK( m.matches("Hello, EECS 211.") );
    CHECK( m.matches("Hello, EECS 211!") );
    CHECK_FALSE( m.matches("Hello, EECS 211?") );

    CHECK( m.to_string() == "(and (starts-with \"Hello\") "
                                    "(or (ends-with \".\") "
                                    "(ends-with \"!\")))" );
}
